IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'CONSULTA_DESONERACAO'
              AND TYPE = 'P'
              AND U.UID = O.UID
              AND U.NAME = USER)
DROP PROCEDURE CONSULTA_DESONERACAO
GO

CREATE PROCEDURE CONSULTA_DESONERACAO @P_CDFILIAL VARCHAR(04),
                                      @P_NRLANCTONF VARCHAR(10),
                                      @P_VRDESONERA FLOAT OUTPUT
AS

   DECLARE @V_VRDESONERA   FLOAT;
   DECLARE @V_CDDESTINO    VARCHAR(50);
   DECLARE @V_IDORIGDESTNF VARCHAR(01);
   DECLARE @V_SEMDESONERA  VARCHAR(01);

   /* VARIVEIS DO CURSOR C_IMPOSTO */
   DECLARE @V_IMPOSTO_CDFILIAL        VARCHAR(04);
   DECLARE @V_IMPOSTO_NRLANCTONF      VARCHAR(10);
   DECLARE @V_IMPOSTO_NRSEQITPROD     VARCHAR(04);
   DECLARE @V_IMPOSTO_CDPRODUTO       VARCHAR(10);
   DECLARE @V_IMPOSTO_CDIMPOSTO       VARCHAR(02);
   DECLARE @V_IMPOSTO_CDFISCALIT      VARCHAR(01);
   DECLARE @V_IMPOSTO_IDIMPDESONERAIT VARCHAR(01);
   DECLARE @V_IMPOSTO_VRIMPOSTOIT     FLOAT;
BEGIN
   
   SET @V_VRDESONERA = 0;
   
   SET @V_SEMDESONERA = 'S';
   
   SELECT @V_CDDESTINO = ISNULL(MAX(CDCLIENTE), ISNULL(MAX(CDFORNECED), CASE MAX(IDENTRSAIDOP) WHEN 'S' THEN MAX(CDFILIRECE) ELSE MAX(CDFILIEMIT) END)),
          @V_IDORIGDESTNF = MAX(IDORIGDESTNF)
     FROM NOTAFISCAL
    WHERE CDFILIAL = @P_CDFILIAL
      AND NRLANCTONF = @P_NRLANCTONF;

   DECLARE C_IMPOSTO CURSOR FOR (SELECT IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD, IT.CDPRODUTO,
                                        IP.CDIMPOSTO, IP.CDFISCALIT, IP.IDIMPDESONERAIT, IP.VRIMPOSTOIT
                                   FROM ITEMPRODUTO IT, ITEMPROIMPOS IP, IMPOSTO IM, PRODUTO PR
                                  WHERE IP.CDFILIAL = IT.CDFILIAL
                                    AND IP.NRLANCTONF = IT.NRLANCTONF
                                    AND IP.NRSEQITPROD = IT.NRSEQITPROD
                                    AND IM.CDIMPOSTO = IP.CDIMPOSTO
                                    AND PR.CDPRODUTO = IT.CDPRODUTO
                                    AND IT.CDFILIAL = @P_CDFILIAL
                                    AND IT.NRLANCTONF = @P_NRLANCTONF
                                    AND IM.IDDESONERAIMPO = 'S'
                                    AND EXISTS (SELECT PC.CDPRODUTO, PC.CDCLIENTE AS DESTINO
                                                  FROM PRODESONERAIMCLI PC, PRODUTO PRO
                                                 WHERE PRO.CDPRODUTO = PC.CDPRODUTO
                                                   AND PC.CDCLIENTE = @V_CDDESTINO
                                                   AND @V_IDORIGDESTNF = 'C'
                                                   AND CHARINDEX(ISNULL(RTRIM(PRO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1
                                                 UNION ALL
                                                SELECT PF.CDPRODUTO, PF.CDFORNECED AS DESTINO
                                                  FROM PRODESONERAIMFOR PF, PRODUTO PRO
                                                 WHERE PRO.CDPRODUTO = PF.CDPRODUTO
                                                   AND PF.CDFORNECED = @V_CDDESTINO
                                                   AND @V_IDORIGDESTNF = 'F'
                                                   AND CHARINDEX(ISNULL(RTRIM(PRO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1
                                                 UNION ALL
                                                SELECT PL.CDPRODUTO, PL.CDFILIAL AS DESTINO
                                                  FROM PRODESONERAIMFIL PL, PRODUTO PRO
                                                 WHERE PRO.CDPRODUTO = PL.CDPRODUTO
                                                   AND PL.CDFILIAL = @V_CDDESTINO
                                                   AND @V_IDORIGDESTNF = 'L'
                                                   AND CHARINDEX(ISNULL(RTRIM(PRO.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1));

      OPEN C_IMPOSTO;

      FETCH NEXT FROM C_IMPOSTO INTO @V_IMPOSTO_CDFILIAL, @V_IMPOSTO_NRLANCTONF, @V_IMPOSTO_NRSEQITPROD, @V_IMPOSTO_CDPRODUTO,
                                     @V_IMPOSTO_CDIMPOSTO, @V_IMPOSTO_CDFISCALIT, @V_IMPOSTO_IDIMPDESONERAIT, @V_IMPOSTO_VRIMPOSTOIT;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_SEMDESONERA = 'N';

         SET @V_VRDESONERA = @V_VRDESONERA + @V_IMPOSTO_VRIMPOSTOIT;

         UPDATE ITEMPROIMPOS
            SET IDIMPDESONERAIT = 'S'
          WHERE CDFILIAL = @V_IMPOSTO_CDFILIAL
            AND NRLANCTONF = @V_IMPOSTO_NRLANCTONF
            AND NRSEQITPROD = @V_IMPOSTO_NRSEQITPROD
            AND CDIMPOSTO = @V_IMPOSTO_CDIMPOSTO;

         UPDATE TRABITPROIMPOS
            SET IDIMPDESOTRABIT = 'S'
          WHERE CDFILIMPOIT = @V_IMPOSTO_CDFILIAL
            AND NRLANCIMPOIT = @V_IMPOSTO_NRLANCTONF
            AND NRSEQIMPOIT = @V_IMPOSTO_NRSEQITPROD
            AND CDIMPOSTOIT = @V_IMPOSTO_CDIMPOSTO;

         UPDATE IMPOSTONF
            SET IDIMPDESONERANF = 'S'
          WHERE CDFILIAL = @V_IMPOSTO_CDFILIAL
            AND NRLANCTONF = @V_IMPOSTO_NRLANCTONF
            AND CDIMPOSTO = @V_IMPOSTO_CDIMPOSTO;

         UPDATE ITEMPRODUTO
            SET VRCONTITEM = VRCONTITEM - @V_IMPOSTO_VRIMPOSTOIT
          WHERE CDFILIAL = @V_IMPOSTO_CDFILIAL
            AND NRLANCTONF = @V_IMPOSTO_NRLANCTONF
            AND NRSEQITPROD = @V_IMPOSTO_NRSEQITPROD;

      FETCH NEXT FROM C_IMPOSTO INTO @V_IMPOSTO_CDFILIAL, @V_IMPOSTO_NRLANCTONF, @V_IMPOSTO_NRSEQITPROD, @V_IMPOSTO_CDPRODUTO,
                                     @V_IMPOSTO_CDIMPOSTO, @V_IMPOSTO_CDFISCALIT, @V_IMPOSTO_IDIMPDESONERAIT, @V_IMPOSTO_VRIMPOSTOIT;

   END;

   CLOSE C_IMPOSTO;

   DEALLOCATE C_IMPOSTO;

   IF @V_SEMDESONERA = 'S' BEGIN
      SET @P_VRDESONERA = 0;
   END ELSE BEGIN
      SET @P_VRDESONERA = @V_VRDESONERA;
   END;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'IMPOSTO_SAIDA','6.05.xxx';
GO